var functions = {
	// 判断是否登录
	isLogin: function() {
		var userInfo = $.jStorage.get('userinfo');
		if(userInfo == "" || userInfo == null || userInfo == undefined) {
			return false;
		} else if(userInfo.token == "" || userInfo.token == null || userInfo.token == undefined) {
			return false;
		} else {
			return true;
		}
	},
	// 获取TOKEN
	getToken: function() {
		var userInfo = $.jStorage.get('userinfo');
		if(userInfo == "" || userInfo == null || userInfo == undefined) {
			// 未登录跳转登录界面
			window.location.href = "jlogin.html";
		} else if(userInfo.token == "" || userInfo.token == null || userInfo.token == undefined) {
			// 未登录跳转登录界面
			window.location.href = "jlogin.html";
		} else {
			//已登录
			return userInfo.token;
		}
	},
	// 判断为空
	isNull: function(obj) {
		return $.isEmptyObject(obj);
	},
	// 判断不为空
	isNotNull: function(obj) {
		return !$.isEmptyObject(obj);
	},
	// 时间戳转换成日期格式
	timestampToTimeYMD: function(timestamp) {
		var date = new Date(timestamp * 1000); //时间戳为10位需*1000，时间戳为13位的话不需乘1000
		var Y = date.getFullYear() + '年';
		var M = (date.getMonth() + 1 < 10 ? '0' + (date.getMonth() + 1) : date.getMonth() + 1) + '月';
		var D = date.getDate() + '日';
		return Y + M + D;
	},
	timestampToTimeYMD2: function(timestamp) {
		var date = new Date(timestamp * 1000); //时间戳为10位需*1000，时间戳为13位的话不需乘1000
		var Y = date.getFullYear() + '-';
		var M = (date.getMonth() + 1 < 10 ? '0' + (date.getMonth() + 1) : date.getMonth() + 1) + '-';
		var D = date.getDate();
		return Y + M + D;
	},
	dateToTimeYMD: function(date) {		
		var d = new Date(date);
		d = d.getFullYear() > 0 ? d : new Date(date.replace(/-/g, "/"))
		var Y = d.getFullYear() + '年';
		var M = (d.getMonth() + 1 < 10 ? '0' + (d.getMonth() + 1) : d.getMonth() + 1) + '月';
		var D = d.getDate() + '日';
		return Y + M + D;
	},
	//获取URL参数
	getUrlParam: function(name) {
		var reg = new RegExp("(^|&)" + name + "=([^&]*)(&|$)"); //构造一个含有目标参数的正则表达式对象
		var r = window.location.search.substr(1).match(reg); //匹配目标参数
		if(r != null) return unescape(r[2]);
		return null; //返回参数值
	},
	//弹出框-打开加载中
	openLoading: function(){
		popup({type:'load',msg:"请等待"});
	},
	//弹出框-关闭加载中
	closeLoading: function(){
		$('.mask').remove();
		Dialog.prototype.close();
	},
	//弹出框-关闭加载中并提示成功
	dialogSuccess: function(){
		functions.closeLoading();
		popup({type:'success',msg:"操作成功",delay:1500});
	},
	//弹出框-关闭加载中并提示失败信息
	dialogError: function(msg){
		functions.closeLoading();
		popup({type:'error',msg:msg,delay:2000});
	},
	//没有订单
	dialogOrder:function(){
		functions.closeLoading();
		popup({type:'error',msg:"没有订单",delay:3000});
	},
	//操作失败
	dialogFail:function(){
		functions.dialogError("操作失败");
	},
	//提示信息
    dialogTips:function(msg){
		functions.closeLoading();
		popup({type:'tip',msg:msg,clickDomCancel:true,delay:null});
	},
	//提示文本
    dialogText:function(msg){
		popup({type:'text',msg:msg,clickDomCancel:true,delay:null});
	},
	//首页爱提提提示文本
    dialogText2:function(msg){
		popup({type:'text2',msg:msg,clickDomCancel:true,delay:2000});
	}	
}