/*****
j0slider.js-20160808gz
Author: https://github.com/jiu0
*/

/* j0slider 函数运用 */
j0slider();

/* j0slider 函数机制 -0.05*/
function j0slider() {

	/*1、基础函数*/
	//html标签是否带某属性
	function j0hasattr(obj, a) {
		if(typeof(obj.attr(a)) == 'undefined') {
			return false;
		} else {
			return true;
		}
	} /*0.5*/
	//索引值 纠偏
	function j0idx(i, n) {
		i = parseFloat(i);
		//循环式1, 不记旧
		//if(i<0){i=n-1;}if(i>=n){i=0;}

		/*循环式2, 记旧
		var j=[];
		if(i<0){j.push(n-1).push(-1);}
		if(i>=n){j.push(0).push(n);}
		i=j[0];*/

		//线段式 当到线段断点，需及时 停止自动播放。不建议此法。
		if(i < 0) {
			i = 0;
		}
		if(i >= n) {
			i = n - 1;
		}

		return i;
	}

	//索引值 加1
	function j0addidx(i, n) {
		i = j0idx(i, n);
		i = i + 1;
		return i;
	} /*0.5*/

	//索引值 减1
	function j0cutidx(i, n) {
		i = j0idx(i, n);
		i = i - 1;
		return i;
	} /*0.5*/

	/*核心函数：两组对象 同索引一对一 响应*/
	function j0slide(os, ps, i, n, per, fu, j0prev, j0next) {
		i = j0idx(i, n);

		var o = os.eq(i),
			ots = os.not(o);
		var p = ps.eq(i),
			pts = ps.not(p);

		o.addClass('now');
		ots.removeClass('now');

		p.addClass('curr');
		pts.removeClass('curr');
		//var needoft=fuwi-boxwi;
		var oftall = fu.width() - fu.parent().width();
		var ofti = i * per;

		if(oftall <= 0) {
			ofti = 0;
			j0prev.addClass('j0prevno');
			j0next.addClass('j0nextno');

		}
		if(oftall > 0) {
			if(oftall > ofti) {
				ofti = ofti;
				if(i == 0) {
					j0prev.addClass('j0prevno');
					j0next.removeClass('j0nextno');

				} else {
					j0prev.removeClass('j0prevno');
					j0next.removeClass('j0nextno');
				}

			}
			if(oftall <= ofti) {
				ofti = oftall;
				j0prev.removeClass('j0prevno');
				j0next.addClass('j0nextno');

			}
		}

		fu.css({
			'left': (-ofti) + 'px'
		});

		return i;
	} /*0.5*/

	function j0slideprev(os, ps, i, n, per, fu, j0prev, j0next) {
		i = j0cutidx(i, n);
		i = j0slide(os, ps, i, n, per, fu, j0prev, j0next);
		return i;
	}

	function j0slidenext(os, ps, i, n, per, fu, j0prev, j0next) {
		i = j0addidx(i, n);
		i = j0slide(os, ps, i, n, per, fu, j0prev, j0next);
		return i;
	}
	/*2、思路逻辑 */

	$(function() {
		/** 全局函数定义1 **/
		var j0boxes = $('.j0sbox'); //范围
		j0boxes.each(function(j, el) {
			var j0box = $(el);
			var j0bs = j0box.find('.j0sb'); //响应组成员(图)  must
			var j0num = j0bs.length; //响应组成员数量

			j0bs.find('.j0pic').removeClass('rt');

			if(j0num) {

				var j0scr = j0box.find('.j0scr');
				j0scr.width(j0box.width());
				var j0fu = j0box.find('.j0sbs'); //响应组父 移动(ul)
				var j0prev = j0box.find('.j0sprev'); //上箭头 must
				var j0next = j0box.find('.j0snext'); //下箭头 must
				var j0onff = j0box.find('.j0sonff'); //开关(暂停或继续) must
				var j0idx = 0 //当前索引值 初始值

				/* 间隔是否为土模式。1代表是土模式。 默认为0十模式 */
				var j0tu = j0hasattr(j0box, 'j0tu') ? parseFloat(j0box.attr('j0tu')) : 0;
				/* 算间隔的个数，土模式与帧数相等 */
				var j0gapnum = 0;
				if(j0tu) {
					j0gapnum = j0num;
				} else {
					j0gapnum = j0num - 1;
				}

				//响应组成员 之间的间隔.默认无间隔。
				var j0gap = j0hasattr(j0box, 'j0gap') ? j0box.attr('j0gap') : 0;

				var j0gaps = j0gapnum * j0gap;

				/* 如果指定每页显示几个，则按.scr的宽 重设每个响应组成员的宽度 */
				var j0perpg = j0hasattr(j0box, 'j0perpage') ? j0box.attr('j0perpage') : 0;

				//每次位移多少，也就是单位位移量。可以人工定义。默认则为视窗宽。
				//var j0per=50;//可以在js中人工定义，一般不用此法
				/* 也可以在DOM里人工指定。若无此属性，则默认为视窗宽 */
				var j0per = j0hasattr(j0box, 'j0per') ? j0box.attr('j0per') : j0scr.width();

				var j0bwi = 0,
					j0all = 0;

				/* js 计算j0b的宽度和 fu的宽度*/
				//var pwinwi=window.parent.document.documentElement.clientWidth;
				var j0bwichg = function(ev) {
					var j0per = j0hasattr(j0box, 'j0per') ? j0box.attr('j0per') : j0scr.width();

					if(j0perpg) {
						j0bwi = (j0scr.width() - j0gaps) / j0perpg;
						j0bs.width(j0bwi);
					}
					j0bs.each(function(i, el) {
						j0all = j0all + $(el).width();
					});
					j0all = j0all + j0gaps;
					j0fu.width(j0all);
					j0all = 0;
				}; /*0.05*/
				j0bwichg();
				//window.parent.onresize=j0bwichg;

				/* 如果事先存在激发组(翻页),则干掉它。再通过 js生成 新的激发组*/
				var j0sas = j0box.find('.j0sas');
				j0sas.remove();
				var j0astr = [];
				j0astr.push('<p class="j0sas">');
				j0bs.each(function(i, el) {
					var thu = '';
					var thumb = j0hasattr($(el), 'thumb') ? $(el).attr('thumb') : 0;
					if(thumb) {
						thu = ' style="background-image:url(' + thumb + ');"';
					}
					j0astr.push('<b class="j0sa"' + thu + '>' + (i + 1) + '</b>');
				});
				j0astr.push('</p>');
				j0astr = j0astr.join("\n");
				j0box.append(j0astr);
				/* 重新取激发组(翻页) */
				var j0as = j0box.find('.j0sa');

				//初始需要自动轮换吗。默认不自动轮换。
				var j0autostart = j0hasattr(j0box, 'auto') ? parseFloat(j0box.attr('auto')) : 0;

				//自动轮换记录仪
				var j0itv; //自动轮换ID //setInterval return
				var j0ing = false; //是否正在自动轮换中

				var j0on = false; //是否通过开关 起的!
				var j0ff = false; //是否通过开关 停的!	

				////初始显示1
				var j0ready = function(ev) {
					j0bs.find('.j0pic').addClass('rt');
					j0idx = j0slide(j0as, j0bs, j0idx, j0num, j0per, j0fu, j0prev, j0next);
				}; /*0.05*/
				window.setTimeout(j0ready, 1000);

				////页码功能1

				/* 
					j0as.click(function(){	
					var j=j0as.index(this);
					window.clearInterval(j0itv);
					j0ing=false;j0onff.removeClass('j0ing');j0ff=false;
					j0idx=j0slide(j0as,j0bs,j,j0num,j0per,j0fu,j0prev,j0next);
					}); */

				//鼠标点击某页码时2
				/* j0as.each(function(j,el) {
				$(el).click(function(){	
				window.clearInterval(j0itv);
				j0ing=false;j0onff.removeClass('j0ing');j0ff=false;	
				j0idx=j0slide(j0as,j0bs,j,j0num,j0per,j0fu,j0prev,j0next);
				});
				}); */

				j0as.each(function(j0j, el) {
					//如需捕捉手势, 需 第三方手势库 Hammer.js	
					if(typeof Hammer != 'undefined') { //是否已引入 Hammer.js
						var j0elham = new Hammer(el);

						var j0seetap = function(ev) {
							window.clearInterval(j0itv);
							j0ing = false;
							j0onff.removeClass('j0ing');
							j0ff = false;
							j0idx = j0slide(j0as, j0bs, j0j, j0num, j0per, j0fu, j0prev, j0next);
						};

						j0elham.on('tap', j0seetap); //手点击页码
					}
				});

				////自动轮换的控制

				//开关外观初始化2
				if(j0ing) {
					j0onff.addClass('j0ing');
				} else {
					j0onff.removeClass('j0ing');
				}

				////轮换初始化1
				var j0slide0 = function() {
					j0idx = j0slidenext(j0as, j0bs, j0idx, j0num, j0per, j0fu, j0prev, j0next);
					if(j0next.hasClass('j0nextno')) {
						window.clearInterval(j0itv);
						j0ing = false;
						j0onff.removeClass('j0ing');
						j0ff = false;
					}
				};
				if(j0autostart) {
					var j0ready2 = function() {
						j0itv = window.setInterval(j0slide0, 2000);
						j0ing = true;
						j0onff.addClass('j0ing');
						j0on = false;
					};
					window.setTimeout(j0ready2, 1100);
				}

				//开关 暂停或继续 2
				j0onff.click(function() {
					if(j0ing) {
						window.clearInterval(j0itv);
						j0ing = false;
						j0onff.removeClass('j0ing');
						j0ff = true;
					} else {
						j0itv = window.setInterval(j0slide0, 2000);
						j0ing = true;
						j0onff.addClass('j0ing');
						j0on = true;
					}
				});

				/*鼠标悬停 暂停或继续 2,  仅PC端适用
				j0box.mouseover(function(){
				if(j0ing&&!j0on){//可以停吗,如果不是通过开关而继续的，就可以停
				window.clearInterval(j0itv);j0ing=false;j0onff.removeClass('j0ing');j0ff=false;
				}
				}).mouseout(function(){
				if(!j0ing&&!j0ff){//可以起吗,如果不是通过开关而停的，就可以起
				j0itv = window.setInterval(j0slide0,2000);
				j0ing=true;j0onff.addClass('j0ing');j0on=false;
				}
				});*/

				////上下项箭头功能1
				var j0seeprev = function(ev) {
					ev.preventDefault();
					window.clearInterval(j0itv);
					j0ing = false;
					j0onff.removeClass('j0ing');
					j0ff = false;
					j0idx = j0slideprev(j0as, j0bs, j0idx, j0num, j0per, j0fu, j0prev, j0next);
				};
				var j0seenext = function(ev) {
					ev.preventDefault();
					window.clearInterval(j0itv);
					j0ing = false;
					j0onff.removeClass('j0ing');
					j0ff = false;
					j0idx = j0slidenext(j0as, j0bs, j0idx, j0num, j0per, j0fu, j0prev, j0next);
				};

				//上箭头2
				//j0prev.click(j0seeprev);
				//下箭头2
				//j0next.click(j0seenext);

				//如需捕捉手势, 需 第三方手势库 Hammer.js
				var j0prevdom = j0prev[0];
				if(typeof Hammer != 'undefined') { //是否已引入 Hammer.js
					var j0prevham = new Hammer(j0prevdom);
					j0prevham.on('tap', j0seeprev); //上箭头2
				}

				//如需捕捉手势, 需 第三方手势库 Hammer.js
				var j0nextdom = j0next[0];
				if(typeof Hammer != 'undefined') { //是否已引入 Hammer.js
					var j0nextham = new Hammer(j0nextdom);
					j0nextham.on('tap', j0seenext); //上箭头2
				}

				//如需捕捉手势, 需 第三方手势库 Hammer.js
				var j0boxdom = j0box[0];
				if(typeof Hammer != 'undefined') { //是否已引入 Hammer.js
					var j0boxham = new Hammer(j0boxdom);
					j0boxham.on('swiperight', j0seeprev); //手往右边滑动,想看左边的内容 ~= 上箭头2
					j0boxham.on('swipeleft', j0seenext); //手往左边滑动,想看右边的内容 ~= 下箭头2
				}

			}
		});
	}); //0

} //-0.05

/*****  jiu0-20160330gz *****/